<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;

class ItempenerimaanbarangioModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "itempenerimaanbarangio";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "itempenerimaanbarangio";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "rcNumber", "itemId", "receiptDate", "quantity", "lokasiId", "lotNumber", "date_updated", "is_sync"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "itempenerimaanbarangio.id",
        "itemId" => "itempenerimaanbarangio.itemId",
        "rcNumber" => "itempenerimaanbarangio.rcNumber",
        "quantity" => "itempenerimaanbarangio.quantity",
        "receiptDate" => "itempenerimaanbarangio.receiptDate",
        "lokasiId" => "itempenerimaanbarangio.lokasiId",
        "lotNumber" => "itempenerimaanbarangio.lotNumber",
    ];

    /**
     * relation from ' . item . ' by ' . itemId
     * join item on item.id = itempenerimaanbarangio.itemId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItemId($alias = "itemId")
    {
        $this->getQuery()->join("item as $alias", "$alias.id", "=", "itempenerimaanbarangio.itemId");
        return $this;
    }

    /**
     * relation from ' . penerimaanbarang . ' by ' . penerimaanBarangId
     * join penerimaanbarang on penerimaanbarang.poNumber = itempenerimaanbarangio.penerimaanBarangId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationPenerimaanBarangIoId($alias = "penerimaanBarangIoId")
    {
        $this->getQuery()->join("penerimaanbarangio as $alias", "$alias.rcNumber", "=", "itempenerimaanbarangio.rcNumber");
        return $this;
    }

    public function joinRelationLokasiId($alias = "lokasiId")
    {
        $this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "itempenerimaanbarangio.lokasiId");
        return $this;
    }

    public function syncFromOracleHO($syncTable)
    {
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();

        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        $oracleOCI->closeConnection();
    }

    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "SELECT
  IOV.SHIPMENT_NUMBER,
  IOV.INVENTORY_ITEM_ID,
  IOV.QTY,
  IOV.LAST_UPDATE_DATE
FROM (
       SELECT
         tmp.*,
         ROWNUM rn
       FROM (SELECT *
             FROM pelni_iot_v) tmp
        IOV
WHERE
  IOV.LAST_UPDATE_DATE >= TO_DATE('" . Carbon::parse($staging->last_sync) . "', 'yyyy-mm-dd HH24:MI:SS')
  ORDER BY IOV.LAST_UPDATE_DATE ASC";
        return $query;
    }


    public function mapperOracle($oracle)
    {
        $this->poNumber = $oracle->SHIPMENT_NUMBER;
        $this->itemId = $oracle->INVENTORY_ITEM_ID;
        $this->quantity = $oracle->QTY;
    }

    public function storingDataFromOracle($oracle)
    {
        $modelExists = (new self())->getQuery()->where("itempenerimaanbarangio.poNumber", "=", $oracle->SHIPMENT_NUMBER)
            ->where("itempenerimaanbarangio.itemId", "=", $oracle->INVENTORY_ITEM_ID)
            ->where("itempenerimaanbarangio.quantity", "=", $oracle->QTY)
            ->first();
        if (!$modelExists) {
            try {
                $model = new self();
                $model->mapperOracle($oracle);
                $model->save();
                echo $model->id . " inserted ", PHP_EOL;
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
            }
        }
    }

    public function updateTransactionSyncFlag($TRANSACTION_NUM, $ITEM_ID, $LOT_NUMBER)
    {
        $model = (new self())->getQuery()->where("itempenerimaanbarangio.rcNumber", "=", $TRANSACTION_NUM)
            ->where("itempenerimaanbarangio.itemId", "=", $ITEM_ID)
            ->where("itempenerimaanbarangio.lotNumber", "=", $LOT_NUMBER)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->is_sync = 1;
            $model->update();
            // (new LogsynckapalModel)->setLogSync("Update Sync Flag Transfer IO: " . $TRANSACTION_NUM . " - " . $LOT_NUMBER . " - " . $LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "updated");
        }
    }

    // RETURN NUMBER OF ROWS AS INTEGER, FOR ITEMS WITH LOT_NUMBER AND IS_SYNC IS NULL
    public function validUpdateStock($ITEM_ID, $LOT_NUMBER)
    {
        $model = (new self())->getQuery()
            ->selectRaw('COUNT("itempenerimaanbarangio"."itemId") as "nItems"')
            ->where("itempenerimaanbarangio.itemId", "=", $ITEM_ID)
            ->where("itempenerimaanbarangio.lotNumber", "=", $LOT_NUMBER)
            ->whereNull("itempenerimaanbarangio.is_sync")
            ->groupBy("itemId")
            ->first();
        if ($model) {
            return $model->nItems;
        } else {
            return 0;
        }
    }
}
